 ozone <- read.table("ozone.txt",header=T)
 summary (ozone[,c("maxO3","T12")])

  plot(maxO3~T12,data=ozone,pch=15,cex=.5)
 simple.reg <- lm(maxO3~T12,data=ozone)
 summary(simple.reg) 
 names(simple.reg)

 	simple.reg$coef
 coef(simple.reg) 
 reg.without.intercept <- lm(maxO3~T12-1, data=ozone)
 plot(maxO3~T12,data=ozone,pch=15,cex=.5)
 abline(simple.reg)

 res.simple<-rstudent(simple.reg)
 plot(res.simple,pch=15,cex=.5,ylab="Residuals")
 abline(h=c(-2,0,2),lty=c(2,1,2))

 xnew <- 19
 xnew <- as.data.frame(xnew)
 colnames(xnew) <- "T12"
 predict(simple.reg,xnew,interval="pred")

 	gridx <- data.frame(T12=seq(min(ozone[,"T12"]),max(ozone[,"T12"]), length=100))
 	CIline <- predict(simple.reg,new=gridx, interval="conf",level=0.95)
 	CIpred <- predict(simple.reg,new=gridx, interval="pred",level=0.95)
 plot(maxO3~T12,data=ozone,pch=15,cex=.5)
 matlines(gridx,cbind(CIline,CIpred[,-1]),lty=c(1,2,2,3,3),col=1)
 	legend("topleft",lty=2:3,c("pred","conf"))

  eruption.lm <-  lm(eruptions ~ waiting, data=faithful)
  coeffs<-  coefficients(eruption.lm); coeffs 
  waiting<-  80            
  duration = coeffs[1] + coeffs[2]*waiting 
  duration 

  newdata<- data.frame(waiting=80) 
  predict(eruption.lm, newdata)     
  eruption.lm = lm(eruptions ~ waiting, data=faithful)
  summary(eruption.lm)$r.squared 
  help(summary.lm)
  eruption.lm <- lm(eruptions ~ waiting, data=faithful)
  summary(eruption.lm) 

  help(summary.lm)

  eruption.lm <- lm(eruptions ~ waiting, data=faithful)
  newdata = data.frame(waiting=80)
  predict(eruption.lm, newdata, interval="confidence") 

  detach(faithful)     
  eruption.lm <- lm(eruptions ~ waiting, data=faithful)
  newdata = data.frame(waiting=80)

  predict(eruption.lm, newdata, interval="predict") 
  detach(faithful)     # clean up
  help(predict.lm)

  eruption.lm <- lm(eruptions ~ waiting, data=faithful)

  eruption.res<-  resid(eruption.lm)
  plot(faithful$waiting, eruption.res,
       ylab="Residuals", xlab="Waiting Time",
       main="Old Faithful Eruptions") 
  abline(0, 0)                  # the horizon

  help(resid)
  eruption.lm <- lm(eruptions ~ waiting, data=faithful)
  eruption.stdres = rstandard(eruption.lm)
  plot(faithful$waiting, eruption.stdres,
       ylab="Standardized Residuals",
       xlab="Waiting Time",
       main="Old Faithful Eruptions") 
  abline(0, 0)                  # the horizon
  help(rstandard)
  eruption.lm <- lm(eruptions ~ waiting, data=faithful)
.  eruption.stdres = rstandard(eruption.lm)

  qqnorm(eruption.stdres,
         ylab="Standardized Residuals",
         xlab="Normal Scores",
         main="Old Faithful Eruptions") 
  qqline(eruption.stdres)
  help(qqnorm)

 ozone <- read.table("ozone.txt",header=T)
 ozone.m <- ozone[,1:11]
 names(ozone.m)
  reg.mul <- lm(maxO3~.,data=ozone.m)
  summary(reg.mul)
 library (leaps)
 choice <- regsubsets(maxO3~.,data=ozone.m,nbest=1,nvmax=11)
 plot(choice,scale="bic")
  summary(choice)$which[which.min(summary(choice)$bic),]
 final.reg <- lm(maxO3~T12+Ne9+Wx9+maxO3y,data=ozone.m)
 summary(final.reg)

 res.m <- rstudent(final.reg)
 plot(res.m,pch=15,cex=.5,ylab="Residuals")
 abline(h=c(-2,0,2),lty=c(2,1,2))

 xnew <- matrix(c(19,8,2.05,70),nrow=1)
 colnames(xnew) <- c("T12","Ne9","Wx9","maxO3y")
 xnew <- as.data.frame(xnew)
 predict(final.reg,xnew,interval="pred")

  help(stackloss)

  stackloss.lm = lm(stack.loss~Air.Flow + Water.Temp + Acid.Conc.,data=stackloss)
# wrap the parameters 
  newdata = data.frame(Air.Flow=72,Water.Temp=20,Acid.Conc.=85)
  predict(stackloss.lm, newdata) 

  stackloss.lm = lm(stack.loss~Air.Flow + Water.Temp + Acid.Conc.,data=stackloss)
  summary(stackloss.lm)$r.squared 
  stackloss.lm = lm(stack.loss~Air.Flow + Water.Temp + Acid.Conc.,data=stackloss)
  summary(stackloss.lm)
  help(summary.lm)
  stackloss.lm = lm(stack.loss~Air.Flow + Water.Temp + Acid.Conc.,data=stackloss)
  summary(stackloss.lm) 
  help(summary.lm)
  stackloss.lm = lm(stack.loss~Air.Flow + Water.Temp + Acid.Conc.,data=stackloss)

  newdata = data.frame(Air.Flow=72,Water.Temp=20,Acid.Conc.=85)
    predict(stackloss.lm, newdata, interval="confidence")
  detach(stackloss)    # clean up
  help(predict.lm)
  stackloss.lm = lm(stack.loss~Air.Flow + Water.Temp + Acid.Conc.,data=stackloss)
  newdata = data.frame(Air.Flow=72,Water.Temp=20,Acid.Conc.=85)
  predict(stackloss.lm, newdata, interval="predict") 
  detach(stackloss)    # clean up

 Spectrum <- read.table("Spectrum_Breizh.txt", sep=";",header=TRUE, row.names=1)
 row.mean <- apply(Spectrum[,-1], 1, mean)
 Spectrum[,-1] <- sweep(Spectrum[,-1], 1, row.mean, FUN="-")
 row.sd <- apply(Spectrum[,-1], 1, sd)
 Spectrum[,-1] <- sweep(Spectrum[,-1], 1, row.sd, FUN="/")

 hist(Spectrum[,"OC"], freq=F, xlab="Organic Carbon content")
 lines(density(Spectrum[,"OC"]))
 rug(Spectrum[,"OC"])

 which(Spectrum[,1] 8) 
 Spectrum[79,1] 
 max(Spectrum[-79,1]) 
   	Spectrum <- Spectrum[-79,]
 	color <- as.numeric(cut(Spectrum[,1], quantile(Spectrum[,1], prob=seq(0,1,by=1/7)), include.lowest = TRUE))
 	matplot(x=400:2500, y=t(as.matrix(Spectrum[,-1])),type="l", lty=color, col=color,xlab="Wavelength",ylab="Reflectance")

 library(pls)
 pls.model <- plsr(OC~., ncomp=100, data=Spectrum, scale=TRUE, validation="CV")
 msepcv.pls <- MSEP(pls.model, estimate=c("train","CV"))
 plot(msepcv.pls,col=1,type="l",legendpos="topright",main="")
 ncp <- which.min(msepcv.pls$val["CV",,])-1
 	reg.pls <- plsr(OC~., ncomp=ncp, data=Spectrum, scale=TRUE)
 res.pls <- residuals(reg.pls)
 plot(res.pls[,,ncp],pch=15,cex=.5,ylab="Residuals",main="")
 abline(h=c(-2,0,2), lty=c(2,1,2))

 ReflecN <- read.table("Spectrum_new.txt", sep=";", header=TRUE, row.names=1)
 row.meanN <- apply(ReflecN[,-1], 1, mean)
 ReflecN[,-1] <- sweep(ReflecN[,-1], 1, row.meanN, FUN="-")
 row.sdN <- apply(ReflecN[,-1], 1, sd)
 ReflecN[,-1] <- sweep(ReflecN[,-1], 1, row.sdN, FUN="/")
   pred <- predict(reg.pls, ncomp=ncp, newdata=ReflecN[,-1])
  ReflecN[,1]
  plot(reg.pls, plottype="coef", comps=1:ncp, main="",
       legendpos="topleft", xlab="Wavelength", labels=400:2500)
 colo <- rep(1,nrow(Spectrum))
 colo[substr(rownames(Spectrum),0,4)=="rmqs"] <- "grey30"
 plot(reg.pls, plottype="scores", comps=c(1,2),col=colo,asp=1)
 abline(h=0,lty=2)
 abline(v=0,lty=2)
 color <- grey(seq(0,.9,len=ncol(Spectrum)))
 plot(pls.model,plottype="cor",comps=1:2,col=color,pch=20)
 	plot(pls.model,plottype="loadings",labels=400:2500,comps=1:ncp,
       legendpos="topright",xlab="Wavelength",ylab="Loadings")
 	abline(h=0,lty=2)

  insurance <- read.csv("insurance.csv", stringsAsFactors = TRUE)
   str(insurance)
  summary(insurance)
  install.packages("psych")
  library(psych)
  pairs.panels(insurance[c("age", "bmi", "children", "charges")])
