 ozone <- read.table("ozone.txt",header=T)
 summary(ozone[,c("maxO3","wind")])
  plot(maxO3~wind,data=ozone,pch=15,cex=.5)
 reg.aov1 <- lm(maxO3~wind,data=ozone)
 anova(reg.aov1) 
 res.aov1 <- rstudent(reg.aov1)

 library(lattice)
 mypanel  <- function(...) {
  panel.xyplot(...)
  panel.abline(h=c(-2,0,2),lty=c(3,2,3),...) 
}

 trellis.par.set(list(fontsize=list(point=5,text=8)))
 xyplot(res.aov1~I(1:112)|wind, data=ozone, pch=20, ylim=c(-3,3),
        panel=mypanel,ylab="Residuals", xlab="")
  summary(reg.aov1)
  summary(lm(maxO3~C(wind,base=2),data=ozone))
  summary(lm(maxO3~C(wind,sum),data=ozone))
 options (contrasts = c("contr.sum", "contr.sum"))  
   summary (lm(maxO3~wind,data=ozone))
  data(InsectSprays)
  str(InsectSprays)
  summary(InsectSprays)

  attach(InsectSprays)
  tapply(count, spray, mean)
  tapply(count, spray, var)
  tapply(count, spray, length)              # okay, as there are no missing values

  boxplot(count ~ spray)          
  oneway.test(count ~ spray)      
  oneway.test(count ~ spray, var.equal=TRUE)
  bartlett.test(count ~ spray, data=InsectSprays)
  fligner.test(x=InsectSprays$count, g=InsectSprays$spray)
  library(car)               
  leveneTest(y=InsectSprays$count, group=InsectSprays$spray)
  leveneTest(y=InsectSprays$count, group=InsectSprays$spray, center=mean)
  aov.out = aov(count ~ spray, data=InsectSprays)
  summary(aov.out)
  oneway.test(count ~ spray, data=InsectSprays, var.eq=T)
  par(mfrow=c(1,2))          # γραφικά σε μια γραμμή και δυο στήλες e
  plot(aov.out, 1)           # έλεγχος ομοιογένειας 
  plot(aov.out, 2)           # έλεγχος κανονικότητας 
  boxplot(aov.out$resid ~ InsectSprays$spray)
  TukeyHSD(aov.out)

  attach(InsectSprays)
  meancounts = tapply(count, spray, mean)
  var(meancounts)
  summary(aov(count ~ spray))
  power.anova.test(groups=6, between.var=44.48, within.var=15.38, power=.9)
  kruskal.test(count ~ spray, data=InsectSprays)
  aov.out = aov(count ~ spray, data=InsectSprays)
  TukeyHSD(aov.out)                    # just run TukeyHSD() on the model object
  (5.532742-(-3.866075))/2   # HSD τιμή ελέγχου για την σύγκριση των  B-A 
  plot(TukeyHSD(aov.out), las=1)  # las=1 δείχνει ετικέτες στον άξονα 
  with(InsectSprays, pairwise.t.test(x=count, g=spray, p.adjust="none"))       # x=DV, g=IV
  summary.lm(aov.out)$coef             # summary.lm(aov.out) is sufficient, but there is more output
  with(InsectSprays, pairwise.t.test(x=count, g=spray, p.adjust="bonferroni"))
  with(InsectSprays, pairwise.t.test(x=count, g=spray, p.adjust="holm"))
  data(PlantGrowth)
  summary(PlantGrowth)
  with(PlantGrowth, tapply(weight, group, mean))
  with(PlantGrowth, tapply(weight, group, var))
  with(PlantGrowth, bartlett.test(weight ~ group))
  levels(PlantGrowth$group)
  vec1 <-  c(1,-1/2,-1/2)
  vec2 <-  c(0,1,-1)
  cons<- cbind(vec1, vec2)
  cons
  rownames(cons) <-  c("ctrl", "trt1", "trt2")
  cons
  t(cons) %*% cons
  contrasts(PlantGrowth$group)<-  cons
  aov.out <-  aov(weight ~ group, data=PlantGrowth)
  summary(aov.out,split=list(group=list("ctrl v trts"=1, "trt1 v trt2"=2)))
  summary.lm(aov.out)$coef

 ozone <- read.table("ozone.txt",header=T)
 summary(ozone[,c("maxO3","wind","rain")])
  boxplot(maxO3~wind*rain,data=ozone)
 par(mfrow=c(1,2))
 with(ozone,interaction.plot(wind,rain,maxO3))
 with(ozone,interaction.plot(rain,wind,maxO3))
 mod.int <- lm(maxΟ3~wind*rain,data=ozone)
 anova(mod.int) 

 mod.without.int <- lm(maxO3~wind+rain,data=ozone)
 anova(mod.without.int) 

  summary(lm(maxΟ3~C(wind,sum)+C(rain,sum),data=ozone))
 options(contrasts = c("contr.sum", "contr.sum")) 
   summary(lm(max03~wind+rain+wind:rain,data=ozone))
 summary(lm(max03~wind+rain,data=ozone))  #χωρίς επιρροή

 cider <- read.table("cider.csv",header=TRUE,sep=",")
 dim(cider) 
 summary(cider[,c(1,2,4)])

plot(Sweetness~Bitterness,pch=as.numeric(Type),data=cider)
legend("topright",levels(cider$Type),pch=1:nlevels(cider$Type))

 library(lattice) 
 xyplot (Sweetness~Bitterness|Type, data=cider) 
 	global <- lm(Sweetness~-1+Type+Type:Bitterness, data=cider)
 slopeU <- lm(Sweetness~-1 + Type + Bitterness, data = cider) 
 interceptU <- lm(Sweetness ~ Type:Bitterness, data = cider)
 	anova(slopeU,global)
 	anova(interceptU,global)
 simple <- lm(Sweetness ~ Bitterness,data = cider)
 anova(simple,slopeU) 
 anova1 <- lm(Sweetness ~ Type,data = cider)
 anova(anova1,slopeU) 
 xyplot(rstudent(chosen_model)~Bitterness|Type, ylab="res", data=cider)
 library(car)
 global <- lm(Sweetness~Type+Bitterness+Type:Bitterness, data=cider)
 Anova(global, type="III")

 global <- lm(Sweetness~Type+Bitterness, data=cider)
 summary (global) 
