 snore_data <- read.table("snore.txt",header=T) 
   summary (snore_data)
 library(MASS)
 model <- lda(snore~.,data=snore_data)
 model1 <- lda(snore~age+alcohol+sex+tobacco,data=snore_data)
 model2 <- lda(snore~.,data=snore_data,prior=c(0.5,0.5))
 model3 <- lda(snore~age+alcohol+sex+tobacco,data=snore_data,
               prior=c(0.5,0.5))
 model2
 pred <- lda(snore~.,data=snore_data,CV=TRUE)$class
 table(pred,snore_data$snore)
 	sum(pred!=snore_data$snore)/nrow(snore_data)
 	sum(pred!=snore_data$snore)/nrow(snore_data)

 table(pred1,snore_data$snore)
 sum(pred1!=snore_data$snore)/nrow(snore_data) 
 pred2 <- lda(snore~.,data=snore_data,prior=c(0.5,0.5),
              CV=TRUE)$class
 table(pred2,snore_data$snore)
 sum(pred2!=snore_data$snore)/nrow(snore_data) 
 pred3 <- lda(snore~age+alcohol+sex+tobacco,data=snore_data,
              prior=c(0.5,0.5),CV=TRUE)$class
 table(pred3,snore_data$snore)
 sum(pred3!=snore_data$snore)/nrow(snore_data) 
 new_d1 <- matrix(c(42,55,169,0,58,94,185,4,35,70,180,6,67,63,166,3), ncol=4,byrow=T)
 new_d2 <- matrix(c("W","N","M","Y","M","Y","W","N"),ncol=2,byrow=T)
 new_d <- cbind.data.frame(new_d1,new_d2)
 names(new_d) <- names(snore_data)[-6]

   predict(model,newdata=new_d)
 library(MASS)
 help(Pima.te)
 attach(Pima.te)
 summary(Pima.te)
 model_0 <- glm(type~age,data=Pima.te,family=binomial)
 summary(model_0)
 beta <- coef(model_0)
 age<- seq(20,85,by=1)
 y=exp( -2.51558+0.05618*age)/(1+exp(-2.51558 + 0.05618*age))
 plot(age,y,type="l",xlab="age",ylab="p(x)")
 abline(h=0.5,lty=2)
 xlim <- -beta[1]/beta[2]
 abline(v=xlim,lty=2)
 full.fit <- glm(formula=type~npreg+glu+bp+skin+bmi+ped+age, 
                 data=Pima.te, family=binomial)

 or<-round(exp(full.fit$coef),4)
 full.sum<-summary(full.fit)$coef
 upper.ci<-round(exp(full.sum[,1]+1.96*full.sum[,2]),4)
 lower.ci<-round(exp(full.sum[,1]-1.96*full.sum[,2]),4)
 ci<-cbind(or,upper.ci,lower.ci)
 colnames(ci)<-c("or","upper.ci","lower.ci")

 anova(model_0,full.fit,test="Chisq")
 model_step <- step(model,direction="backward")
 model_step <- step(full.fit,direction="backward")

 new_d <-   data.frame(matrix(c(5,140,76,70,20,0.6,40,1,80,70,25,
                                45,0.56,25,8,120,60,27,30,0.5,44,
                                2,91,50,68,23,0.7,34), ncol=7, byrow=T))
 names(new_d) <- names(Pima.te)[-c(3,4,7,8)]
 prediction <- predict(model_step,newdata=new_d,type="response")
 prediction
 predict.prob<- predict(model_step,newdata=Pima.te,type="response")

  prediction_label <- as.numeric(predict.prob > 0.5)
  table(Pima.te$type,prediction_label)
 data(iris)
 names(iris)
 summary(iris)

  install.packages("caret")
  library(lattice)
  library(ggplot2)
  library(caret)
  data(iris)
  attach(iris)

  inTrain<- createDataPartition(y=iris$Species,p=0.7,list=FALSE)
  training<- iris[inTrain,]
  testing<- iris[-inTrain,]

  library(rpart)
  modFit<- train(Species~.,method="rpart",data=training)
  print(modFit$finalModel)
  plot(modFit$finalModel,uniform=TRUE,main="classification Tree")
  text(modFit$finalModel,use.n=TRUE,all=TRUE,cex=0.8)
 install.packages("rattle")
 install.packages("rpart.plot")
 library(rattle)
 fancyRpartPlot(modFit$finalModel)
 predict(modFit,newdata=testing)
  pred<- predict(modFit,newdata=testing)
  tab<- table(testing$Species,pred)

  error <- sum(pred!=testing$Species)/nrow(testing)
 library(car)
# install.packages('rattle')
 data(wine, package='rattle')
 attach(wine)
 head(wine)
 scatterplotMatrix(wine[2:6])
 library(MASS)
 wine.lda <- lda(Type ~ ., data=wine)
 wine.lda.values <- predict(wine.lda)
 ldahist(data = wine.lda.values$x[,1], g=Type)
 ldahist(data = wine.lda.values$x[,2], g=Type)

 plot(wine.lda.values$x[,1],wine.lda.values$x[,2]) # make a scatterplot
 text(wine.lda.values$x[,1],wine.lda.values$x[,2],
      Type,cex=0.7,pos=4,col="red") # add labels

## Διάβασε τα δεδομένα(read data )
 credit <- read.csv("http://www.biz.uiowa.edu/faculty/jledolter/DataMining/germancredit.csv")
  ## Δες τις μεταβλητές σου 
    str(credit)
 head(credit,2) # See details about codification in the attached documentation.
 cred1=credit[, c("Default","duration","amount","installment","age")]
 head(cred1)
 summary(cred1)
 hist(cred1$duration)
 hist(cred1$amount)
 hist(cred1$installment)
 hist(cred1$age)
# Transform selected data into a data.frame to make LDA
 cred1=data.frame(cred1)
library(MASS)
attach(cred1)
## LDA: Δίνουμε τις  εκ των προτέρων ( prior)  πιθανότητες  probabilities
zlin=lda(Default~.,cred1)

# πίνακας διάχυσης(Confusion Matrix):
table(predict(zlin)$class, Default)

# προβλέψεις για δυο νέες τιμές:
 predict(zlin,newdata=data.frame(duration=6,amount=1100,installment=4,age=67))
 predict(zlin,newdata=data.frame(duration=6,amount=1100,installment=4,age=67))$class
 
 install.packages("rpart")
 library(rpart)
 mytree <- rpart(Default ~ .,data=credit, method = "class")
 summary(mytree)
 print(mytree)
 plot(mytree, uniform=TRUE, main="Classification Tree for credit", margin = 0.2)
 text(mytree, use.n=TRUE, all=TRUE, cex=.75)
 