#source code of Chapter 3 SMLR
 	demo(graphics)
  data(trees)
  View(trees)
  summary(trees)
 plot(trees$Height)
  plot(trees$Height, type="l")
  data("anscombe")
  summary(anscombe)

  par(mfrow=c(2,2))
  #διαιρούμε το παράθυρο σε 4 ίσα παράθυρα 2x2, επανέρχεται 
  #το ενιαίο παράθυρο με par(mfrow=c(1,1))
  plot(y1~x1, anscombe)
  plot(y2~x2, anscombe)
  plot(y3~x3, anscombe)
  plot(y4~x4, anscombe)

 example("anscombe") 
  plot(y1~x1, anscombe)
 gridx <- seq(0,1,length=50)
 fx <- sin(2*pi*gridx)
 plot(x=gridx,y=fx)

  plot(fx~gridx)
 	ozone <- read.table("ozone.txt",header=T)
 ozone <- ozone[,c("T12","maxO3","wind","rain","Wx12")]

 summary(ozone)

  plot(ozone[,"maxO3"]~ozone[,"T12"])
  plot(maxO3~T12,data=ozone)
 	plot(ozone[,"maxO3"]~ozone[,"T12"],xlab="T12",ylab="maxO3")
 	plot(maxO3~wind,data=ozone,xlab="Wind directions",
       ylab="Maximum Ozone Concentration")
 	boxplot(maxO3~wind,data=ozone)
 	plot(rain~wind,data=ozone)
  plot(wind~T12,data=ozone)
 	spineplot(wind~T12,data=ozone)
 	plot(ozone[,"T12"],ozone[,"wind"],yaxt="n",xlab="T12", ylab="wind",pch="+")
 	axis(side=2,at=1:4,labels=levels(ozone[,"wind"]))
 plot(ozone[,"maxO3"],xlab="num.",ylab="maxO3",cex=.5,pch=16)
 plot(ozone[,"maxO3"],xlab="num.",ylab="maxO3",type="l")
 hist(ozone[,"maxO3"],main="Histogram",prob=TRUE,xlab="Ozone")
 plot(density(ozone[,"maxO3"]),main="Kernel Density Estimate", xlab="Ozone")
  barplot(table(ozone[,"wind"]))
  plot(ozone[,"wind"])
 plot(maxO3~T12,data=ozone,type="n")
 text(ozone[,"T12"],ozone[,"maxO3"],substr(rownames(ozone),5, 8),cex=.75)
 plot(maxO3~T12,data=ozone,type="p",pch=3,cex=.75)
 text(ozone[,"T12"],ozone[,"maxO3"],substr(rownames(ozone),5, 8), 
      cex=.75,pos=3,offset=.3) 
 selection <- ozone[,"rain"]=="Rainy"
 points(ozone[selection,"T12"],ozone[selection,"maxO3"],
        pch=21,bg="grey70",cex=.75)
  abline(v=27,lty=2)
 plot(ozone[1:7,"maxO3"],type="l")
 lines(ozone[8:14,"maxO3"],col="grey50") # add lines (2nd week)
 rangey <- range(ozone[1:7,"maxO3"],ozone[8:14,"maxO3"])
 plot(ozone[1:7,"maxO3"],type="l",ylim=rangey,lty=1)
 lines(ozone[8:14,"maxO3"],col="grey50",lty=1)

 f <- function(x,y)  10 * sin(sqrt(x^2+y^2))/ sqrt(x^2+y^2)
 x <- seq(-10, 10, length= 30)
 y <- x

 	z <- outer(x, y, f)
 	persp(x, y, z, theta = 30, phi = 30, expand = 0.5)
 library(rgl)
 rgl.surface(x, y, z)
 library(lattice)
 cloud(maxO3~T12+Wx12,type=c("p","h"),data=ozone)

  plot3d(ozone[,"T12"],ozone[,"Wx12"],ozone[,"maxO3"], 
         radius=2, xlab="T12",ylab="Wx12",zlab="maxO3",type="s")

 e <- rnorm(200,0,15)
 x <- sample(0:100,size=200,replace=T)
 y <- sample(50:200,size=200,replace=T)
 z <- 30-3*x+e
 matrix1 <- cbind(x,y,z)
 dimnames(matrix1) <- list(NULL,c("X","Y","Z"))
 pairs(matrix1)

  tab <- read.table("people2.csv",sep=",",header=TRUE)
  pie(table(tab$Eye.Color))

 pdf("graphik.pdf")
 rangey <- range(ozone[1:7,"maxO3"],ozone[8:14,"maxO3"])
 plot(ozone[1:7,"maxO3"],type="l",ylim=rangey,lty=1)
 lines(ozone[8:14,"maxO3"],col="grey50",lty=1)
 dev.off()

 par(mfrow=c(1,2))
 plot(1:10,10:1,pch=0)
 plot(rep(1,4),type="l")

  mat <- matrix(c(1,1,2,3), nrow=2, ncol=2, byrow = TRUE)
 layout(mat)
 plot(1:10,10:1,pch=0)
 plot(rep(1,4),type="l")
 plot(c(2,3,-1,0),type="b")

 plot(1:10,10:1,pch=0)
 X11()
 plot(rep(1,4),type="l")

 	plot(x,y,type="p",pch=o,col="red")
 	par(fg="blue",bg="#f2a1c2")
 palette(gray(seq(0,0.9,len=10))) # palette of grey
 plot(1:10,rep(1,10),type="p",pch=25,bg=1:10)
 palette("default")
 	plot(x,y,type="p",pch=o,main="My Title")
  plot(c(10,11),c(12,11),type="p",axes=FALSE,xlab="",ylab="") 

 axis(1,at=c(10,11),label=c("Dim 1","Dim 2"))
   	plot(x,y,type="p",asp=1)
   rangey <- range(ozone[1:7,"maxO3"], ozone[8:14,"maxO3"])
   plot(ozone[1:7,"maxO3"],type="l")
   lines(ozone[8:14,"maxO3"],ylim=rangey, col="grey50")
 legend("topleft", legend=c("week 1","week 2"), col = c("black", "grey50"), lty=1)
   	plot(1,1,xlab=expression(bar(x)==sum(frac(x[i], n), i==1,n)))

 library(lattice)
 data(quakes)
 breakpts <- quantile(quakes$depth,probs=seq(0,1,length=7))
 class <- cut(quakes$depth, breaks=breakpts, include.lowest=TRUE)
 levels(class) <- c("grey80","grey65","grey50","grey35", "grey10","black")
 plot(lat ~ long,data=quakes,col=as.character(class),pch=16)

 Depth <- equal.count(quakes$depth,number = 6,overlap=0.05)
 xyplot(lat ~ long | Depth, data = quakes,pch="+",
        xlab = "Longitude", ylab = "Latitude")

  plot(Depth)
 data(state)
 states <- data.frame(state.x77, state.name= rownames(state.x77), 
                      state.region = state.region)
 	income <- equal.count(states[,"Income"],number=3)
   	xyplot(Murder ~ Population | state.region, data = states)
  xyplot(Murder ~ Population | state.region*income, data = states)
  xyplot(Murder~Population|income, groups=state.region, 
         data=states, auto.key=TRUE,type="p")
  xyplot(Murder ~ Population | income,data=states, panel=mypanel)

 fontsize <-trellis.par.get("fontsize")
 fonsize$text <- 8
 fontsize$points <- 5
 trellis.par.set("fontsize",fonsize)
 	plot.symbol <- trellis.par.get("plot.symbol")
  plot.symbol$cex <- 0.5
  trellis.par.get("plot.symbol",plot.symbol)

 cex <- 0.5 # symbol magnification
 xlab <- list("my title for x-axis",cex=0.7) # title for x axis
 ylab <- list(cex=0.7) # no title for y axis
 scales <- list(cex=0.5) # size of the graduations
 	densityplot(~Murder|income,data=states,layout=c(3,1))

 show.settings(standard.theme("postscript")) # black and white
 show.settings(col.whitebg()) # default
 show.settings(standard.theme("quartz")) # quartz
   trellis.device(device="pdf",theme = standard.theme("postscript"), 
                  file="export.pdf")
  # my lattice expression(s)   
   dev.off()
