 octopus <- read.table("OctopusF.txt",header=T)
 dim(octopus) 

 summary (octopus)

 	mean(octopus$Weight)
 	sd(octopus$Weight)
 	hist(octopus[,"Weight"],main="",nclass=15,freq=FALSE,
       ylab="Density",xlab="Weight")
  t.test (octopus$Weight,conf.level=0.95)$conf.int 
attr(,"conf.level") 

 	mean(octopus$Weight)-qt(0.975, df=239)*sd (octopus$Weight)/sqrt (240) 
 	mean(octopus$Weight)+qt(0.975, df=239)*sd (octopus$Weight)/sqrt (240) 

 colour<-matrix(c(592,544,119,97,849,677,504,451,36,14),ncol=5)
 rownames(colour)<-c("Boys","Girls")
  colnames(colour)<-c("Fair","Red","Medium","Dark","Jet Black")

 par(mfrow=c(2,1))
 barplot(colour[1,],main="Boys")
 barplot(colour[2,],main="Girls")

 	round(100  * colour / sum(colour), 1)
 	round(100  * prop.table  (colour, margin =1), 1)
 	round(100  * prop.table  (colour, margin =2), 1)

 results <- chisq.test(colour)
 	round(100 * results$residuals^2 / results$stat, 1)
 	round(results$residuals, 3)
 cont.tab <- xtabs(~colour+sex, data=dataset)
 chisq.test(cont.tab)

  library(MASS)        
  tbl<-  table(survey$Smoke, survey$Exer) 
  tbl                 

  chisq.test(tbl) 

  ctbl <-  cbind(tbl[,"Freq"], tbl[,"None"] + tbl[,"Some"]) 

  chisq.test(ctbl) 

 octopus <- read.table(Octopus.csv,header=T,sep=;) 
#Summary of the dataset:
   summary(octopus)
 octopus[, "Sex" ] <- factor(octopus[, "Sex" ]) 
  boxplot(Weight ~ Sex, ylab="Weight", xlab="Sex", data=octopus)

 tapply(octopus[,"Weight"], octopus[,"Sex"], mean, na.rm=TRUE)
 tapply(octopus[,"Weight"], octopus[,"Sex"], sd, na.rm=TRUE)
 	tapply(octopus[,"Weight"],octopus[,"Sex"],quantile,na.rm=TRUE)

 select.males <- octopus[,"Sex"]=="Male"
 qqnorm(octopus[select.males,"Weight"])
 qqline(octopus[select.males,"Weight"],col="grey")
 shapiro.test(octopus[select.males,"Weight"])

  var.test (Weight ~ Sex, conf.level=.95,data=octopus)
  t.test(Weight~Sex, alternative="two.sided", conf.level=.95, var.equal=FALSE, data=octopus)
 nbr.vot.A <- round(0.524 * 1040,0)
 binom.test(nbr.vot.A, n=1040, p=0.5, alternative="greater")
  binom.test(nbr.vot.A,n=1040) 
  prop.test(c(592,119,849,504,36),n=c(1136,216,1526,955,50))

  library(MASS)        
  tbl<-  table(survey$Smoke, survey$Exer) 
  levels(survey$Smoke) 
    smoke.freq = table(survey$Smoke) 
  smoke.prob = c(.045, .795, .085, .075) 
  chisq.test(smoke.freq, p=smoke.prob) 

  power.t.test(delta=1, sd=1.7, sig.level=0.05, power=0.8) 
 	power.t.test(n=20, delta=1, sd=1.7, sig.level=0.05)$power
 	power.t.test(n=20, sd=1.7, sig.level=0.05, power=0.8)$delta
 var(c(28, 30, 31)) 
 power.anova.test(groups=3, between.var=2.3333,within.var=2.89, power=.80)
